<template>
  <div>
    <div v-show="status === Status.LOADING">
      <content-loader-table
        :height="350"
        :num-rows="5"
      />
    </div>
    <div v-show="status === Status.SUCCESS">
      <b-table
        :current-page="currentPage"
        :fields="fields"
        :items="fetchTags"
        :per-page="perPage"
        :sort-by.sync="sortBy"
        :sort-desc.sync="sortDesc"
        bordered
        small
        striped
      >
        <template #cell(actions)="data">
          <b-link :to="buildMatchingLociRoute(data.item)">
            View Loci
          </b-link>
        </template>
      </b-table>
      <!-- This <b-row>...</b-row> block builds the pagination function for the table. -->
      <b-row align-h="between">
        <b-col>
          <b-row>
            <b-col>
              <b-form inline>
                <label class="mr-2">Show</label>
                <b-form-select
                  v-model="perPage"
                  :options="pageOptions"
                  class="mr-2"
                />
                <label class="mr-1">entries</label>
              </b-form>
            </b-col>
          </b-row>
          <b-row>
            <b-col>
              <p class="font-weight-lighter">
                Showing {{ pageStart }} to {{ pageEnd }} of {{ rows }} entries
              </p>
            </b-col>
          </b-row>
        </b-col>
        <b-col>
          <b-pagination
            v-model="currentPage"
            :per-page="perPage"
            :total-rows="rows"
            align="right"
          />
        </b-col>
      </b-row>
    </div>
    <div v-show="status === Status.ERROR">
      <b-list-group>
        <b-list-group-item variant="danger">
          <h5>Error Loading Tags</h5>
          <p>There was an error loading tags.</p>
          <pre>{{ JSON.stringify(errorMessage, null, 2) }}</pre>
        </b-list-group-item>
      </b-list-group>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { BvTableCtxObject } from 'bootstrap-vue';

import { TagService } from '@/api';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';
import { Tag } from '@/common/types';

/* eslint-disable-next-line no-shadow */
enum Status {
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    ContentLoaderTable,
  },

  data() {
    return {
      Status,
      count: 0,
      currentPage: 1,
      errorMessage: '',
      fields: [
        {
          key: 'id',
          label: 'Name',
        },
        {
          key: 'description',
          label: 'Description',
        },
        {
          key: 'actions',
          label: 'Actions',
        },
      ],
      loading: false,
      sortBy: 'id',
      sortDesc: true,
      status: Status.LOADING,
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 5,
    };
  },

  computed: {
    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
    pageStart(): number {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    rows(): number {
      return this.count;
    },
  },

  methods: {
    buildMatchingLociRoute(tag: Tag): object {
      return {
        name: 'locusList',
        query: {
          query: JSON.stringify({
            filters: [
              {
                type: 'terms',
                field: 'tags',
                value: [tag.id],
                text: `Tags: ${tag.id}`,
              },
            ],
          }),
        },
      };
    },

    async fetchTags(ctx: BvTableCtxObject) {
      this.status = Status.LOADING;
      try {
        const { data: tags, meta } = await TagService.list({
          page: {
            limit: ctx.perPage,
            offset: (ctx.currentPage - 1) * ctx.perPage,
          },
          ...(ctx.sortBy && { sort: (ctx.sortDesc ? '-' : '') + ctx.sortBy }),
        });
        this.count = meta.count;
        this.status = Status.SUCCESS;
        return tags;
      } catch (error) {
        /* eslint-disable-next-line prefer-destructuring */
        this.errorMessage = error[0];
        this.status = Status.ERROR;
      }
      return null;
    },
  },
});
</script>

<style scoped></style>
